/* <begin connected objects> */
/*
This file is auto generated by pgrx.

The ordering of items is not stable, it is driven by a dependency graph.
*/
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:12
-- bootstrap
CREATE TABLE dd.meta_schema
(
    meta_schema_id BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY,
    s_name name NOT NULL,
    data_source TEXT NULL,
    sensitive BOOLEAN NOT NULL DEFAULT False,
    CONSTRAINT PK_dd_meta_schema_id PRIMARY KEY (meta_schema_id),
    CONSTRAINT UQ_dd_meta_schema_name UNIQUE (s_name)
);


CREATE TABLE dd.meta_table
(
    meta_table_id BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY,
    s_name name NOT NULL,
    t_name name NOT NULL,
    data_source TEXT NULL,
    sensitive BOOLEAN NOT NULL DEFAULT False,
    CONSTRAINT PK_dd_meta_table_id PRIMARY KEY (meta_table_id),
    CONSTRAINT UQ_dd_meta_table_schema_table UNIQUE (s_name, t_name)
);


CREATE TABLE dd.meta_column
(
    meta_column_id BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY,
    s_name name NOT NULL,
    t_name name NOT NULL,
    c_name name NOT NULL,
    data_source TEXT NULL,
    sensitive BOOLEAN NOT NULL DEFAULT False,
    CONSTRAINT PK_dd_meta_column_id PRIMARY KEY (meta_column_id),
    CONSTRAINT UQ_dd_meta_column_schema_table_column UNIQUE (s_name, t_name, c_name)
);
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:16
-- requires:
--   create_extension_tables_all

INSERT INTO dd.meta_schema (s_name, data_source, sensitive)
    VALUES ('dd', 'Manually maintained', False);


INSERT INTO dd.meta_table (s_name, t_name, data_source, sensitive)
    VALUES ('dd', 'meta_schema', 'Manually maintained', False);
INSERT INTO dd.meta_table (s_name, t_name, data_source, sensitive)
    VALUES ('dd', 'meta_table', 'Manually maintained', False);
INSERT INTO dd.meta_table (s_name, t_name, data_source, sensitive)
    VALUES ('dd', 'meta_column', 'Manually maintained', False);


INSERT INTO dd.meta_column (s_name, t_name, c_name, data_source, sensitive)
    VALUES ('dd', 'meta_column', 'sensitive', 'Manually defined', False)
;

SELECT pg_catalog.pg_extension_config_dump('dd.meta_schema'::regclass, 'WHERE s_name <> ''dd'' ');
SELECT pg_catalog.pg_extension_config_dump('dd.meta_schema_meta_schema_id_seq'::regclass, '');

SELECT pg_catalog.pg_extension_config_dump('dd.meta_table'::regclass, 'WHERE s_name <> ''dd'' ');
SELECT pg_catalog.pg_extension_config_dump('dd.meta_table_meta_table_id_seq'::regclass, '');

SELECT pg_catalog.pg_extension_config_dump('dd.meta_column'::regclass, 'WHERE s_name <> ''dd'' ');
SELECT pg_catalog.pg_extension_config_dump('dd.meta_column_meta_column_id_seq'::regclass, '');
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:52
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.views_all AS
SELECT n.nspname::TEXT AS s_name,
    c.relname::TEXT AS v_name,
        CASE c.relkind
            WHEN 'v'::"char" THEN 'view'::text
            WHEN 'm'::"char" THEN 'materialized view'::text
            ELSE NULL::text
        END AS view_type,
    pg_get_userbyid(c.relowner)::TEXT AS owned_by,
    c.reltuples::BIGINT AS rows,
    pg_size_pretty(pg_table_size(c.oid::regclass))::TEXT AS size_pretty,
    pg_table_size(c.oid::regclass)::BIGINT AS size_bytes,
    pg_size_pretty(pg_total_relation_size(c.oid::regclass))::TEXT AS size_plus_indexes,
    pg_total_relation_size(c.oid::regclass)::BIGINT AS size_plus_indexes_bytes,
    obj_description(c.oid, 'pg_class'::name)::TEXT AS description,
    CASE
        WHEN n.nspname !~ '^pg_toast'::text AND (n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name]))
            THEN false
        ELSE true
    END AS system_object,
    c.oid
   FROM pg_class c
     LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
  WHERE (c.relkind = ANY (ARRAY['v'::"char", 'm'::"char"]))
;


CREATE OR REPLACE VIEW dd.views AS
SELECT * FROM dd.views_all
    WHERE NOT system_object
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:36
-- requires:
--   create_extension_tables_all

-- Declarative is built-in Postgres partitioning per
--     https://www.postgresql.org/docs/current/ddl-partitioning.html
-- Inheritance includes partitions like Timescale hypertables,
--    but probably includes objects that are not partitions such as
--    https://www.postgresql.org/docs/current/tutorial-inheritance.html
CREATE VIEW dd.partition_parents_all AS
WITH partition_parent AS (
SELECT c.oid,
        n.nspname::TEXT AS s_name,
        c.relname::TEXT AS t_name,
        CASE WHEN pt.partrelid IS NOT NULL THEN 'declarative'
            WHEN c.relkind = 'r' THEN 'inheritance'
            ELSE 'unknown' END AS partition_type,
        COUNT(i.inhrelid) AS partitions
    FROM pg_catalog.pg_class c
    INNER JOIN pg_catalog.pg_inherits i ON c.oid = i.inhparent
    LEFT JOIN pg_catalog.pg_partitioned_table pt
        ON c.oid = pt.partrelid 
    LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
    WHERE c.relkind != 'I' -- Exclude partitioned indexes
    GROUP BY c.relkind, c.oid, pt.partrelid, n.nspname::TEXT, c.relname::TEXT
)
SELECT *
    FROM partition_parent
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:40
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.partition_child_all AS
SELECT c.oid,
        ns.nspname::TEXT AS s_name,
        c.relname::TEXT AS t_name,
        i.inhparent AS parent_oid,
        i.inhparent::regclass::TEXT AS parent_name,
        c.relispartition::BOOLEAN AS declarative_partition,
        pg_catalog.pg_get_expr(c.relpartbound, c.oid)::TEXT
            AS partition_expression
FROM pg_catalog.pg_class c
INNER JOIN pg_catalog.pg_namespace ns ON c.relnamespace = ns.oid
INNER JOIN pg_catalog.pg_inherits i ON c.oid = i.inhrelid
INNER JOIN pg_catalog.pg_class cp ON i.inhparent = cp.oid
    WHERE c.relkind IN ('r', 'p')
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:32
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.index_all AS
SELECT c.oid,
        n.nspname::TEXT AS s_name,
        t.relname::TEXT AS t_name,
        c.relname::TEXT AS i_name,
        i.indnkeyatts AS key_columns,
        i.indnatts AS total_columns,
        i.indisprimary AS primary_key,
        i.indisunique AS unique_index,
        i.indisvalid AS valid_index,
        CASE WHEN i.indpred IS NULL THEN False ELSE True END AS partial_index,
        c.reltuples AS rows_indexed,
        pg_size_pretty(pg_total_relation_size(c.oid::regclass)) AS index_size,
        pg_total_relation_size(c.oid::regclass) AS index_size_bytes,
        CASE
            WHEN n.nspname !~ '^pg_toast'::text
                    AND (n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name]))
                THEN false
            ELSE true
        END AS system_object
    FROM pg_catalog.pg_index i
    INNER JOIN pg_catalog.pg_class c
        ON c.relkind = 'i' AND i.indexrelid = c.oid
    INNER JOIN pg_catalog.pg_class t ON i.indrelid = t.oid
    INNER JOIN pg_catalog.pg_namespace t_n ON t_n.oid = t.relnamespace
    INNER JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace
;


CREATE OR REPLACE VIEW dd.index AS
SELECT * FROM dd.index_all
    WHERE NOT system_object
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:23
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.columns_all AS
SELECT  n.nspname::TEXT AS s_name,
        CASE c.relkind
            WHEN 'r'::"char" THEN 'table'::text
            WHEN 'v'::"char" THEN 'view'::text
            WHEN 'm'::"char" THEN 'materialized view'::text
            WHEN 's'::"char" THEN 'special'::text
            WHEN 'f'::"char" THEN 'foreign table'::text
            WHEN 'p'::"char" THEN 'table'::text
            ELSE NULL::text
        END AS source_type,
    c.relname::TEXT AS t_name,
    a.attname::TEXT AS c_name,
    t.typname::TEXT AS data_type,
    a.attnum AS "position",
    col_description(c.oid, a.attnum::integer) AS description,
    mc.data_source,
    mc.sensitive,
    CASE WHEN (n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name])) AND n.nspname !~ '^pg_toast'::text
        THEN False
        ELSE True
        END AS system_object,
    (SELECT pg_catalog.pg_get_expr(d.adbin, d.adrelid, true) AS default_expression
        FROM pg_catalog.pg_attrdef d
        WHERE d.adrelid = a.attrelid
            AND d.adnum = a.attnum
            AND a.atthasdef) AS default_value,
    CASE WHEN a.attgenerated = '' THEN False 
        ELSE True 
        END AS generated_column
   FROM pg_attribute a
     JOIN pg_class c ON a.attrelid = c.oid
     JOIN pg_namespace n ON n.oid = c.relnamespace
     JOIN pg_type t ON a.atttypid = t.oid
     LEFT JOIN dd.meta_column mc ON n.nspname = mc.s_name AND c.relname = mc.t_name AND a.attname = mc.c_name
  WHERE a.attnum > 0 AND (c.relkind = ANY (ARRAY['r'::"char", 'p'::"char", 's'::"char", 'v'::"char", 'f'::"char", 'm'::"char"]))
;



CREATE OR REPLACE VIEW dd.columns AS
SELECT * FROM dd.columns_all
    WHERE NOT system_object
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:48
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.tables_all AS
SELECT n.nspname::TEXT AS s_name,
    c.relname::TEXT AS t_name,
        CASE
            WHEN c.relkind = ANY (ARRAY['r'::"char", 'p'::"char"]) THEN 'table'::text
            WHEN c.relkind = 's'::"char" THEN 'special'::text
            WHEN c.relkind = 'f'::"char" THEN 'foreign table'::text
            ELSE NULL::text
        END AS data_type,
    pg_get_userbyid(c.relowner)::TEXT AS owned_by,
    pg_size_pretty(pg_table_size(c.oid::regclass))::TEXT AS size_pretty,
    pg_table_size(c.oid::regclass)::BIGINT AS size_bytes,
    c.reltuples::BIGINT AS rows,
        CASE
            WHEN c.reltuples > 0::BIGINT
                THEN (pg_table_size(c.oid::regclass)::double precision / c.reltuples)::BIGINT
            ELSE NULL::BIGINT
        END AS bytes_per_row,
    pg_total_relation_size(c.oid::regclass)::BIGINT AS size_plus_indexes_bytes,
    pg_size_pretty(pg_total_relation_size(c.oid::regclass))::TEXT AS size_plus_indexes,

    obj_description(c.oid, 'pg_class'::name)::TEXT AS description,
        CASE
            WHEN n.nspname !~ '^pg_toast'::text AND (n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name])) THEN false
            ELSE true
        END AS system_object,
    mt.data_source,
    mt.sensitive,
    c.oid
   FROM pg_class c
     LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
     LEFT JOIN dd.meta_table mt ON n.nspname = mt.s_name AND c.relname = mt.t_name
  WHERE c.relkind = ANY (ARRAY['r'::"char", 'p'::"char", 's'::"char", 'f'::"char"])
;




CREATE OR REPLACE VIEW dd.tables AS
SELECT * FROM dd.tables_all
    WHERE NOT system_object
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:57
-- requires:
--   partition_parent_all
--   partition_child_all
--   tables_all

/*
    Both final partition views have cross dependencies on their _all views.
    Putting both in this script to make those dependencies clear.

    Could probably be refactored, but not a high priority.
*/

CREATE OR REPLACE VIEW dd.partition_parents AS
WITH partition_details AS (
SELECT p.oid, p.s_name, p.t_name, p.partition_type, p.partitions,
        SUM(t.size_bytes) AS size_bytes,
        -- Check for Postgres 14 and newer
        -- "If the table has never yet been vacuumed or analyzed, reltuples contains -1 indicating that the row count is unknown."
        -- https://www.postgresql.org/docs/current/catalog-pg-class.html
        SUM(CASE WHEN t.rows = -1 THEN NULL ELSE t.rows END) AS rows,
        COUNT(*) FILTER (WHERE t.rows = -1) AS partitions_never_analyzed,
        COUNT(*) FILTER (WHERE t.rows = 0) AS partitions_no_data
    FROM dd.partition_parents_all p
    LEFT JOIN dd.partition_child_all c ON p.oid = c.parent_oid
    LEFT JOIN dd.tables_all t ON c.oid = t.oid
    GROUP BY p.oid, p.s_name, p.t_name, p.partition_type, p.partitions
)
SELECT oid, s_name, t_name, partition_type, partitions,
        size_bytes, pg_size_pretty(size_bytes) AS size_pretty,
        CASE WHEN partitions > 0
            THEN pg_size_pretty(ROUND(size_bytes / partitions))
            ELSE NULL
        END AS size_per_partition,
        rows,
        CASE WHEN partitions > 0
            THEN ROUND(rows / partitions)
            ELSE NULL
        END AS rows_per_partition,
        partitions_never_analyzed,
        partitions_no_data
    FROM partition_details
;


CREATE OR REPLACE VIEW dd.partition_children AS
SELECT pc.oid, pc.s_name, pc.t_name, pc.parent_oid, pc.parent_name,
        t.rows, t.size_bytes, t.size_pretty, t.size_plus_indexes, t.bytes_per_row,
        CASE WHEN pp.rows > 0
            THEN ROUND(t.rows * 1.0 / pp.rows, 4)
            ELSE NULL
            END AS percent_of_partition_rows,
        CASE WHEN pp.size_bytes > 0
            THEN ROUND(t.size_bytes * 1.0 / pp.size_bytes, 4)
            ELSE NULL
            END AS percent_of_partition_bytes
    FROM dd.partition_child_all pc
    INNER JOIN dd.partition_parents pp ON pc.parent_oid = pp.oid
    INNER JOIN dd.tables_all t ON pc.oid = t.oid
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:44
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.schemas_all AS
WITH s AS (
     SELECT n.oid,
        n.nspname AS s_name,
        pg_get_userbyid(n.nspowner) AS owner,
        ms.data_source,
        ms.sensitive,
        obj_description(n.oid, 'pg_namespace'::name) AS description,
            CASE
                WHEN n.nspname !~ '^pg_'::text AND (n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name])) THEN false
                ELSE true
            END AS system_object
       FROM pg_namespace n
         LEFT JOIN dd.meta_schema ms ON n.nspname = ms.s_name
    ), f AS (
    SELECT n.nspname AS s_name,
            count(DISTINCT p.oid) AS function_count
        FROM pg_proc p
        JOIN pg_namespace n ON n.oid = p.pronamespace
        GROUP BY n.nspname
    ), v AS (
    SELECT n.nspname AS s_name,
        count(DISTINCT c_1.oid) AS view_count
        FROM pg_class c_1
        JOIN pg_namespace n ON n.oid = c_1.relnamespace
        WHERE c_1.relkind = ANY (ARRAY['v'::"char", 'm'::"char"])
        GROUP BY n.nspname
    )
SELECT s.s_name::TEXT,
        s.owner::TEXT,
        s.data_source::TEXT,
        s.sensitive::BOOLEAN,
        s.description::TEXT,
        s.system_object,
        COALESCE(count(c.*), 0::bigint)::BIGINT AS table_count,
        COALESCE(v.view_count, 0::bigint)::BIGINT AS view_count,
        COALESCE(f.function_count, 0::bigint)::BIGINT AS function_count,
        pg_size_pretty(sum(pg_table_size(c.oid::regclass)))::TEXT AS size_pretty,
        pg_size_pretty(sum(pg_total_relation_size(c.oid::regclass)))::TEXT AS size_plus_indexes,
        sum(pg_table_size(c.oid::regclass))::BIGINT AS size_bytes,
        sum(pg_total_relation_size(c.oid::regclass))::BIGINT AS size_plus_indexes_bytes
    FROM s
    LEFT JOIN pg_class c
        ON s.oid = c.relnamespace
            AND (c.relkind = ANY (ARRAY['r'::"char", 'p'::"char"]))
    LEFT JOIN f ON f.s_name = s.s_name
    LEFT JOIN v ON v.s_name = s.s_name
    GROUP BY s.s_name, s.owner, s.data_source, s.sensitive,
        s.description, s.system_object, v.view_count,
        f.function_count
;


CREATE OR REPLACE VIEW dd.schemas AS
SELECT * FROM dd.schemas_all
    WHERE NOT system_object
;



COMMENT ON VIEW dd.schemas_all IS 'Data dictionary view: Lists all schemas, including system schemas';
COMMENT ON VIEW dd.schemas IS 'Data dictionary view: Lists schemas, excluding system schemas.';
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:62
-- requires:
--   tables_all
--   views_all
--   schemas_all

CREATE VIEW dd.database AS
WITH db_stats AS (
SELECT d.oid, d.datname AS db_name,
        pg_size_pretty(pg_database_size(d.datname)) AS db_size
    FROM pg_catalog.pg_database d
    WHERE d.datname = current_database()
), schema_stats AS (
SELECT COUNT(s.s_name) AS schema_count
    FROM dd.schemas s
), table_stats AS (
SELECT
        COUNT(t.oid) AS table_count,
        pg_size_pretty(SUM(t.size_plus_indexes_bytes)) AS size_in_tables
    FROM dd.tables t
), view_stats AS (
SELECT
        COUNT(v.oid) AS view_count,
        pg_size_pretty(SUM(v.size_plus_indexes_bytes)) AS size_in_views
    FROM dd.views v
), extension_stats AS (
SELECT COUNT(e.oid) AS extension_count
    FROM pg_catalog.pg_extension e
)
SELECT d.oid, d.db_name::TEXT, d.db_size,
        s.schema_count,
        t.table_count, t.size_in_tables,
        v.view_count, v.size_in_views,
        e.extension_count
    FROM db_stats d
    INNER JOIN table_stats t ON True
    INNER JOIN schema_stats s ON True
    INNER JOIN view_stats v ON True
    INNER JOIN extension_stats e ON True
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:28
-- requires:
--   create_extension_tables_all

CREATE VIEW dd.functions_all AS
SELECT n.nspname::TEXT AS s_name,
        p.proname::TEXT AS f_name,
        pg_get_function_result(p.oid)::TEXT AS result_data_types,
        pg_get_function_arguments(p.oid)::TEXT AS argument_data_types,
        pg_get_userbyid(p.proowner)::TEXT AS owned_by,
            CASE
                WHEN p.prosecdef THEN 'definer'::text
                ELSE 'invoker'::text
            END AS proc_security,
        array_to_string(p.proacl, ''::text) AS access_privileges,
        l.lanname::TEXT AS proc_language,
        p.prosrc::TEXT AS source_code,
        obj_description(p.oid, 'pg_proc'::name)::TEXT AS description,
        CASE
            WHEN n.nspname <> ALL (ARRAY['pg_catalog'::name, 'information_schema'::name]) THEN false
            ELSE true
        END AS system_object
   FROM pg_proc p
     LEFT JOIN pg_namespace n ON n.oid = p.pronamespace
     LEFT JOIN pg_language l ON l.oid = p.prolang
;


CREATE OR REPLACE VIEW dd.functions AS
SELECT * FROM dd.functions_all
    WHERE NOT system_object
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:68
-- pgdd::about
CREATE  FUNCTION "about"() RETURNS TEXT /* &str */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'about_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:74
-- finalize

COMMENT ON SCHEMA dd IS 'Schema for Data Dictionary objects.  See https://github.com/rustprooflabs/pgdd';

COMMENT ON TABLE dd.meta_schema IS 'User definable meta-data at the schema level.';
COMMENT ON TABLE dd.meta_table IS 'User definable meta-data at the schema + table level.';
COMMENT ON TABLE dd.meta_column IS 'User definable meta-data at the schema + table + column level.';

COMMENT ON COLUMN dd.meta_schema.meta_schema_id IS 'Primary key for meta table';
COMMENT ON COLUMN dd.meta_table.meta_table_id IS 'Primary key for meta table';
COMMENT ON COLUMN dd.meta_column.meta_column_id IS 'Primary key for meta table';
COMMENT ON COLUMN dd.meta_schema.s_name IS 'Name of the schema for the object described.';
COMMENT ON COLUMN dd.meta_table.s_name IS 'Name of the schema for the object described.';
COMMENT ON COLUMN dd.meta_column.s_name IS 'Name of the schema for the object described.';
COMMENT ON COLUMN dd.meta_table.t_name IS 'Name of the table for the object described.';
COMMENT ON COLUMN dd.meta_column.t_name IS 'Name of the table for the object described.';
COMMENT ON COLUMN dd.meta_column.c_name IS 'Name of the column for the object described.';

COMMENT ON COLUMN dd.meta_schema.data_source IS 'Optional field to describe the data source(s) for the data in this schema.  Most helpful when objects are intentionally organized by schema.';
COMMENT ON COLUMN dd.meta_table.data_source IS 'Optional field to describe the data source(s) for this table.';
COMMENT ON COLUMN dd.meta_column.data_source IS 'Optional field to describe the data source(s) for this column.';
COMMENT ON COLUMN dd.meta_schema.sensitive IS 'Manually updated indicator. Does the schema contain store sensitive data?';
COMMENT ON COLUMN dd.meta_table.sensitive IS 'Manually updated indicator. Does the table contain store sensitive data?';
COMMENT ON COLUMN dd.meta_column.sensitive IS 'Manually updated indicator. Does the column contain store sensitive data?';


COMMENT ON VIEW dd.tables IS 'Data dictionary view: Lists tables, excluding system tables.';
COMMENT ON VIEW dd.views IS 'Data dictionary view: Lists views, excluding system views.';
COMMENT ON VIEW dd.columns IS 'Data dictionary view: Lists columns, excluding system columns.';
COMMENT ON VIEW dd.functions IS 'Data dictionary view: Lists functions, excluding system functions.';

COMMENT ON FUNCTION dd.about IS 'Basic details about PgDD extension';

COMMENT ON VIEW dd.tables_all IS 'Data dictionary view: Lists all tables';
COMMENT ON VIEW dd.views_all IS 'Data dictionary view: Lists all views.';
COMMENT ON VIEW dd.columns_all IS 'Data dictionary view: Lists all columns';
COMMENT ON VIEW dd.functions_all IS 'Data dictionary view: Lists all functions';
COMMENT ON VIEW dd.partition_parents_all IS 'Data dictionary view: Lists parent partition tables. Column partition_type indicates declarative vs inheritance based partitioning.';
COMMENT ON VIEW dd.partition_child_all IS 'Data dictionary view: Lists partition child tables.';

COMMENT ON VIEW dd.partition_parents IS 'Data dictionary view: Lists parent partition tables with aggregate details about child partitions.';
COMMENT ON COLUMN dd.partition_parents.partition_type IS 'Options declarative and inheritance. Declarative determined by record existing in pg_catalog.pg_partitioned_table. Inheritance based on pg_class.relkind.';
COMMENT ON COLUMN dd.partition_parents.partitions IS 'Count of matching records found in pg_catalog.pg_inherits.';
COMMENT ON COLUMN dd.partition_parents.size_bytes IS 'Sum of size_bytes from matching dd.tables records.';
COMMENT ON COLUMN dd.partition_parents.size_pretty IS 'Size pretty of the size_bytes calculation.';
COMMENT ON COLUMN dd.partition_parents.size_per_partition IS 'size_bytes per partition, pretty format.';
COMMENT ON COLUMN dd.partition_parents.rows IS 'Sum of estimated row counts from matching dd.tables records for all partitions';
COMMENT ON COLUMN dd.partition_parents.rows_per_partition IS 'rows per partition';
COMMENT ON COLUMN dd.partition_parents.partitions_never_analyzed IS 'Number of partition_children that have not been analyzed. New for Postgres 14.';
COMMENT ON COLUMN dd.partition_parents.partitions_no_data IS 'Number of partition_children with 0 rows of data.';

COMMENT ON VIEW dd.partition_children IS 'Data dictionary view: Lists individual partitions (children) of partitioned tables.';
COMMENT ON COLUMN dd.partition_children.parent_oid IS 'oid for the parent of this partitioned table';
COMMENT ON COLUMN dd.partition_children.parent_name IS 'Name of parent partition table, format s_name.t_name.';
COMMENT ON COLUMN dd.partition_children.rows IS 'Estimated row count of this partition.';
COMMENT ON COLUMN dd.partition_children.size_bytes IS 'Size in bytes from dd.tables()';
COMMENT ON COLUMN dd.partition_children.size_pretty IS 'Size pretty from dd.tables().';
COMMENT ON COLUMN dd.partition_children.size_plus_indexes IS 'Size pretty of the table plus indexes';
COMMENT ON COLUMN dd.partition_children.bytes_per_row IS 'Average size per row in bytes';
COMMENT ON COLUMN dd.partition_children.percent_of_partition_rows IS 'Percent of the total row count found in all partitions of the parent table.';
COMMENT ON COLUMN dd.partition_children.percent_of_partition_bytes IS 'Percent of the total size (bytes) used by all partitions of the parent table.';

COMMENT ON VIEW dd.database IS 'Data dictionary view: Provides basic statistics for the current database.';
COMMENT ON COLUMN dd.database.db_size IS 'Size pretty of current database.  Uses pg_database_size() function.';
COMMENT ON COLUMN dd.database.schema_count IS 'Count of non-system schemas, uses dd.schemas view.';
COMMENT ON COLUMN dd.database.table_count IS 'Count of non-system tables, uses dd.tables view.';
COMMENT ON COLUMN dd.database.extension_count IS 'Count of extensions installed in database.';

COMMENT ON VIEW dd.index IS 'Data dictionary view: Details about indexes in current database.';
COMMENT ON COLUMN dd.index.oid IS 'OID for the index.';
COMMENT ON COLUMN dd.index.s_name IS 'Name of the schema for the index described.';
COMMENT ON COLUMN dd.index.t_name IS 'Name of the table for the index described.';
COMMENT ON COLUMN dd.index.i_name IS 'Name of the index';
COMMENT ON COLUMN dd.index.key_columns IS 'Number of columns actually indexed.  Does not count INCLUDE columns. Source: pg_catalog.pg_index.indnkeyatts';
COMMENT ON COLUMN dd.index.total_columns IS 'Total number of columns involved, includes INCLUDE columns.  Source: pg_catalog.pg_index.indnatts';
COMMENT ON COLUMN dd.index.primary_key IS 'Indicates if index is primary key.  Source: pg_catalog.pg_index.indisprimary';
COMMENT ON COLUMN dd.index.unique_index IS 'Indicates if index is unique index.  Source: pg_catalog.pg_index.indisunique';
COMMENT ON COLUMN dd.index.valid_index IS 'Indicates if index is valid.  Source: pg_catalog.pg_index.indisvalid';
COMMENT ON COLUMN dd.index.partial_index IS 'Indicates if index is partial (filtered) index.  Source: pg_catalog.pg_index.indpred';
COMMENT ON COLUMN dd.index.rows_indexed IS 'Estimated number of rows included in the index';
COMMENT ON COLUMN dd.index.index_size IS 'Size of the index formatted for display, reported by pg_size_pretty(pg_total_relation_size()).';
COMMENT ON COLUMN dd.index.index_size_bytes IS 'Size of the index in bytes reported by pg_total_relation_size().';
/* </end connected objects> */

